OGRE-Next: Ogre::v1::BillboardSet Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::v1::BillboardSet Class Reference
Core » Effects

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other. More...

`#include <OgreBillboardSet.h>`

Inheritance diagram for Ogre::v1::BillboardSet:
[legend]

## Public Member Functions
| BillboardSet (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, unsigned int poolSize=20, bool externalDataSource=false, uint8 renderQueueId=110u)
| Usual constructor - this is called by the SceneManager.
| ~BillboardSet () override
virtual SortMode | _getSortMode () const
| Gets the sort mode of this billboard set.
virtual void | _notifyBillboardResized ()
| Internal callback used by Billboards to notify their parent that they have been resized.
virtual void | _notifyBillboardRotated ()
| Internal callback used by Billboards to notify their parent that they have been rotated.
virtual void | _notifyCurrentCamera (const Camera *camera, const Camera *lodCamera)
| Overridden from MovableObject.
void | _releaseManualHardwareResources () override
| Notifies the movable object that hardware resources were lost.
void | _setNullDatablock () override
| Sets the datablock to a null pointer.
virtual void | _sortBillboards ()
| Sort the billboard set.
virtual void | _updateBounds ()
| Update the bounds of the billboardset.
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera) override
| Overridden from MovableObject.
void | _updateRenderQueueImpl (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal version that does not call _notifyCurrentCamera (i.e. you've already done it)
void | beginBillboards (size_t numBillboards=0)
| Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.
virtual void | clear ()
| Empties this set of all billboards.
Billboard * | createBillboard (const Vector3 &position, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set.
Billboard * | createBillboard (Real x, Real y, Real z, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set.
void | endBillboards ()
| Finish defining billboards.
virtual bool | getAutoextend () const
| Returns true if the billboard pool automatically extends.
bool | getAutoUpdate () const
| Return the auto update state of this billboard set.
virtual Billboard * | getBillboard (unsigned int index) const
| Returns a pointer to the billboard at the supplied index.
virtual BillboardOrigin | getBillboardOrigin () const
| Gets the point which acts as the origin point for all billboards in this set.
virtual BillboardRotationType | getBillboardRotationType () const
| Sets billboard rotation type.
bool | getBillboardsInWorldSpace ()
| Gets whether billboards are treated as being in world space.
virtual BillboardType | getBillboardType () const
| Returns the billboard type in use.
virtual const Vector3 & | getCommonDirection () const
| Gets the common direction for all billboards (BBT_ORIENTED_COMMON)
virtual const Vector3 & | getCommonUpVector () const
| Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON)
virtual bool | getCullIndividually () const
| Returns whether or not billboards in this are tested individually for culling.
virtual Real | getDefaultHeight () const
| See setDefaultDimensions - this gets 1 component individually.
virtual Real | getDefaultWidth () const
| See setDefaultDimensions - this gets 1 component individually.
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const String & | getMovableType () const override
| Overridden from MovableObject.
virtual int | getNumBillboards () const
| Returns the number of active billboards which currently make up this set.
virtual unsigned int | getPoolSize () const
| Returns the current size of the billboard pool.
void | getRenderOperation (RenderOperation &op, bool casterPass) override
| Overridden from MovableObject.
virtual bool | getSortingEnabled () const
| Returns true if sorting of billboards is enabled based on their distance from the camera.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden, see Renderable.
virtual Ogre::FloatRect const * | getTextureCoords (uint16 *oNumCoords)
| getTextureCoords() returns the current texture coordinate rects in effect.
virtual bool | getUseAccurateFacing () const
| Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.
bool | getUseIdentityWorldMatrix () const override
| Overriden from Renderable.
void | getWorldTransforms (Matrix4 *xform) const override
| Overridden from MovableObject.
void | injectBillboard (const Billboard &bb, const Camera *camera)
| Define a billboard.
virtual bool | isPointRenderingEnabled () const
| Returns whether point rendering is enabled.
void | notifyBillboardDataChanged ()
| When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about any billboard changes in order to reflect them at the rendering stage.
virtual void | removeBillboard (Billboard *pBill)
| Removes a billboard from the set.
virtual void | removeBillboard (unsigned int index)
| Removes the billboard at the supplied index.
virtual void | setAutoextend (bool autoextend)
| Tells the set whether to allow automatic extension of the pool of billboards.
void | setAutoUpdate (bool autoUpdate)
| Set the auto update state of this billboard set.
virtual void | setBillboardOrigin (BillboardOrigin origin)
| Sets the point which acts as the origin point for all billboards in this set.
virtual void | setBillboardRotationType (BillboardRotationType rotationType)
| Sets billboard rotation type.
virtual void | setBillboardsInWorldSpace (bool ws)
| Sets whether billboards should be treated as being in world space.
virtual void | setBillboardType (BillboardType bbt)
| Sets the type of billboard to render.
void | setBounds (const Aabb &aabb, Real radius)
| Set the bounds of the BillboardSet.
virtual void | setCommonDirection (const Vector3 &vec)
| Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON or BBT_PERPENDICULAR_COMMON.
virtual void | setCommonUpVector (const Vector3 &vec)
| Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON.
virtual void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests billboards in this individually as well as in a group.
void | setDatablock (HlmsDatablock *datablock) override
| Assigns a datablock (i.e. HLMS Material) to this renderable.
virtual void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the billboards in this set.
virtual void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually.
virtual void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually.
void | setMaterial (const MaterialPtr &material) override
| Sets the given material. Overrides HLMS materials.
virtual void | setPointRenderingEnabled (bool enabled)
| Set whether or not the BillboardSet will use point rendering rather than manually generated quads.
virtual void | setPoolSize (size_t size)
| Adjusts the size of the pool of billboards available in this set.
virtual void | setSortingEnabled (bool sortenable)
| Enables sorting for this BillboardSet.
virtual void | setTextureCoords (Ogre::FloatRect const *coords, uint16 numCoords)
| BillboardSet can use custom texture coordinates for various billboards.
virtual void | setTextureStacksAndSlices (uchar stacks, uchar slices)
| setTextureStacksAndSlices() will generate texture coordinate rects as if the texture for the billboard set contained 'stacks' rows of 'slices' images each, all equal size.
virtual void | setUseAccurateFacing (bool acc)
| Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other.

Remarks
  Billboards are rectangles made up of 2 tris which are always facing the given direction. They are typically used for special effects like particles. This class collects together a set of billboards with the same (default) dimensions, material and relative locality in order to process them more efficiently. The entire set of billboards will be culled as a whole (by default, although this can be changed if you want a large set of billboards which are spread out and you want them culled individually), individual Billboards have locations which are relative to the set (which itself derives it's position from the SceneNode it is attached to since it is a MoveableObject), they will be rendered as a single rendering operation, and some calculations will be sped up by the fact that they use the same dimensions so some workings can be reused.

  A BillboardSet can be created using the SceneManager::createBillboardSet method. They can also be used internally by other classes to create effects.

Note
  Billboard bounds are only automatically calculated when you create them. If you modify the position of a billboard you may need to call _updateBounds if the billboard moves outside the original bounds. Similarly, the bounds do no shrink when you remove a billboard, if you want them to call _updateBounds, but note this requires a potentially expensive examination of every billboard in the set.

## Constructor & Destructor Documentation

## ◆ BillboardSet()

Ogre::v1::BillboardSet::BillboardSet | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager,
|  | unsigned int | poolSize = 20,
|  | bool | externalDataSource = false,
|  | uint8 | renderQueueId = 110u )

Usual constructor - this is called by the SceneManager.

Parameters

  name | The name to give the billboard set (must be unique)
  poolSize | The initial size of the billboard pool. Estimate of the number of billboards which will be required, and pass it using this parameter. The set will preallocate this number to avoid memory fragmentation. The default behaviour once this pool has run out is to double it.
  externalDataSource | If `true`, the source of data for drawing the billboards will not be the internal billboard list, but external data. When driving the billboard from external data, you must call _notifyCurrentCamera to reorient the billboards, setPoolSize to set the maximum billboards you want to use, beginBillboards to start the update, and injectBillboard per billboard, followed by endBillboards.

See also
  BillboardSet::setAutoextend

## ◆ ~BillboardSet()

Ogre::v1::BillboardSet::~BillboardSet | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getSortMode()

virtual SortMode Ogre::v1::BillboardSet::_getSortMode | ( |  | ) | const
| virtual

Gets the sort mode of this billboard set.

## ◆ _notifyBillboardResized()

virtual void Ogre::v1::BillboardSet::_notifyBillboardResized | ( |  | ) |
| virtual

Internal callback used by Billboards to notify their parent that they have been resized.

## ◆ _notifyBillboardRotated()

virtual void Ogre::v1::BillboardSet::_notifyBillboardRotated | ( |  | ) |
| virtual

Internal callback used by Billboards to notify their parent that they have been rotated.

## ◆ _notifyCurrentCamera()

virtual void Ogre::v1::BillboardSet::_notifyCurrentCamera | ( | const Camera * | camera,
|  | const Camera * | lodCamera )
| virtual

Overridden from MovableObject.

See also
  MovableObject

## ◆ _releaseManualHardwareResources()

void Ogre::v1::BillboardSet::_releaseManualHardwareResources | ( |  | ) |
| inlineoverridevirtual

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

## ◆ _setNullDatablock()

void Ogre::v1::BillboardSet::_setNullDatablock | ( |  | ) |
| overridevirtual

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented from Ogre::Renderable.

## ◆ _sortBillboards()

virtual void Ogre::v1::BillboardSet::_sortBillboards | ( |  | ) |
| virtual

Sort the billboard set.

Only called when enabled via setSortingEnabled

## ◆ _updateBounds()

virtual void Ogre::v1::BillboardSet::_updateBounds | ( |  | ) |
| virtual

Update the bounds of the billboardset.

## ◆ _updateRenderQueue()

void Ogre::v1::BillboardSet::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| overridevirtual

Overridden from MovableObject.

See also
  MovableObject

Reimplemented from Ogre::MovableObject.

## ◆ _updateRenderQueueImpl()

void Ogre::v1::BillboardSet::_updateRenderQueueImpl | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )

Internal version that does not call _notifyCurrentCamera (i.e. you've already done it)

## ◆ beginBillboards()

void Ogre::v1::BillboardSet::beginBillboards | ( | size_t | numBillboards = 0 | ) |

Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.

Parameters

  numBillboards | If you know the number of billboards you will be issuing, state it here to make the update more efficient.

## ◆ clear()

virtual void Ogre::v1::BillboardSet::clear | ( |  | ) |
| virtual

Empties this set of all billboards.

## ◆ createBillboard() [1/2]

Billboard * Ogre::v1::BillboardSet::createBillboard | ( | const Vector3 & | position,
|  | const ColourValue & | colour = ColourValue::White )

Creates a new billboard and adds it to this set.

Remarks
  Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextend option.

Parameters

  position | The position of the new billboard realtive to the certer of the set
  colour | Optional base colour of the billboard.

Returns
  On success, a pointer to a newly created Billboard is returned.

  On failure (i.e. no more space and can't autoextend), `NULL` is returned.

See also
  BillboardSet::setAutoextend

References Ogre::ColourValue::White.

## ◆ createBillboard() [2/2]

Billboard * Ogre::v1::BillboardSet::createBillboard | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | const ColourValue & | colour = ColourValue::White )

Creates a new billboard and adds it to this set.

Remarks
  Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextend option.

Parameters

  x | The `x` position of the new billboard relative to the center of the set
  y | The `y` position of the new billboard relative to the center of the set
  z | The `z` position of the new billboard relative to the center of the set
  colour | Optional base colour of the billboard.

Returns
  On success, a pointer to a newly created Billboard is returned.

  On failure (i.e. no more space and can't autoextend), `NULL` is returned.

See also
  BillboardSet::setAutoextend

References Ogre::ColourValue::White.

## ◆ endBillboards()

void Ogre::v1::BillboardSet::endBillboards | ( |  | ) |

Finish defining billboards.

## ◆ getAutoextend()

virtual bool Ogre::v1::BillboardSet::getAutoextend | ( |  | ) | const
| virtual

Returns true if the billboard pool automatically extends.

See also
  BillboardSet::setAutoextend

## ◆ getAutoUpdate()

bool Ogre::v1::BillboardSet::getAutoUpdate | ( |  | ) | const
| inline

Return the auto update state of this billboard set.

## ◆ getBillboard()

virtual Billboard * Ogre::v1::BillboardSet::getBillboard | ( | unsigned int | index | ) | const
| virtual

Returns a pointer to the billboard at the supplied index.

Note
  This method requires linear time since the billboard list is a linked list.

Parameters

  index | The index of the billboard that is requested.

Returns
  On success, a valid pointer to the requested billboard is returned.

  On failure, `NULL` is returned.

## ◆ getBillboardOrigin()

virtual BillboardOrigin Ogre::v1::BillboardSet::getBillboardOrigin | ( |  | ) | const
| virtual

Gets the point which acts as the origin point for all billboards in this set.

Returns
  A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

## ◆ getBillboardRotationType()

virtual BillboardRotationType Ogre::v1::BillboardSet::getBillboardRotationType | ( |  | ) | const
| virtual

Sets billboard rotation type.

Returns
  A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ getBillboardsInWorldSpace()

bool Ogre::v1::BillboardSet::getBillboardsInWorldSpace | ( |  | ) |
| inline

Gets whether billboards are treated as being in world space.

## ◆ getBillboardType()

virtual BillboardType Ogre::v1::BillboardSet::getBillboardType | ( |  | ) | const
| virtual

Returns the billboard type in use.

## ◆ getCommonDirection()

virtual const Vector3 & Ogre::v1::BillboardSet::getCommonDirection | ( |  | ) | const
| virtual

Gets the common direction for all billboards (BBT_ORIENTED_COMMON)

## ◆ getCommonUpVector()

virtual const Vector3 & Ogre::v1::BillboardSet::getCommonUpVector | ( |  | ) | const
| virtual

Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON)

## ◆ getCullIndividually()

virtual bool Ogre::v1::BillboardSet::getCullIndividually | ( |  | ) | const
| virtual

Returns whether or not billboards in this are tested individually for culling.

## ◆ getDefaultHeight()

virtual Real Ogre::v1::BillboardSet::getDefaultHeight | ( |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getDefaultWidth()

virtual Real Ogre::v1::BillboardSet::getDefaultWidth | ( |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getLights()

const LightList & Ogre::v1::BillboardSet::getLights | ( |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getMovableType()

const String & Ogre::v1::BillboardSet::getMovableType | ( |  | ) | const
| overridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getNumBillboards()

virtual int Ogre::v1::BillboardSet::getNumBillboards | ( |  | ) | const
| virtual

Returns the number of active billboards which currently make up this set.

## ◆ getPoolSize()

virtual unsigned int Ogre::v1::BillboardSet::getPoolSize | ( |  | ) | const
| virtual

Returns the current size of the billboard pool.

Returns
  The current size of the billboard pool.

See also
  BillboardSet::setAutoextend

## ◆ getRenderOperation()

void Ogre::v1::BillboardSet::getRenderOperation | ( | RenderOperation & | op,
|  | bool | casterPass )
| overridevirtual

Overridden from MovableObject.

See also
  MovableObject

Implements Ogre::Renderable.

## ◆ getSortingEnabled()

virtual bool Ogre::v1::BillboardSet::getSortingEnabled | ( |  | ) | const
| virtual

Returns true if sorting of billboards is enabled based on their distance from the camera.

See also
  BillboardSet::setSortingEnabled

## ◆ getSquaredViewDepth()

Real Ogre::v1::BillboardSet::getSquaredViewDepth | ( | const Camera * | cam | ) | const

Overridden, see Renderable.

## ◆ getTextureCoords()

virtual Ogre::FloatRect const * Ogre::v1::BillboardSet::getTextureCoords | ( | uint16 * | oNumCoords | ) |
| virtual

getTextureCoords() returns the current texture coordinate rects in effect.

By default, there is only one texture coordinate rect in the set, spanning the entire texture from 0 through 1 in each direction.

See also
  BillboardSet::setTextureCoords()

## ◆ getUseAccurateFacing()

virtual bool Ogre::v1::BillboardSet::getUseAccurateFacing | ( |  | ) | const
| inlinevirtual

Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

## ◆ getUseIdentityWorldMatrix()

bool Ogre::v1::BillboardSet::getUseIdentityWorldMatrix | ( |  | ) | const
| overridevirtual

Overriden from Renderable.

Reimplemented from Ogre::Renderable.

## ◆ getWorldTransforms()

void Ogre::v1::BillboardSet::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Overridden from MovableObject.

See also
  MovableObject

Implements Ogre::Renderable.

## ◆ injectBillboard()

void Ogre::v1::BillboardSet::injectBillboard | ( | const Billboard & | bb,
|  | const Camera * | camera )

Define a billboard.

## ◆ isPointRenderingEnabled()

virtual bool Ogre::v1::BillboardSet::isPointRenderingEnabled | ( |  | ) | const
| inlinevirtual

Returns whether point rendering is enabled.

## ◆ notifyBillboardDataChanged()

void Ogre::v1::BillboardSet::notifyBillboardDataChanged | ( |  | ) |
| inline

When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about any billboard changes in order to reflect them at the rendering stage.

Calling this method will cause GPU buffers update in the next render queue update.

## ◆ removeBillboard() [1/2]

virtual void Ogre::v1::BillboardSet::removeBillboard | ( | Billboard * | pBill | ) |
| virtual

Removes a billboard from the set.

Note
  This version is more efficient than removing by index.

## ◆ removeBillboard() [2/2]

virtual void Ogre::v1::BillboardSet::removeBillboard | ( | unsigned int | index | ) |
| virtual

Removes the billboard at the supplied index.

Note
  This method requires linear time since the billboard list is a linked list.

## ◆ setAutoextend()

virtual void Ogre::v1::BillboardSet::setAutoextend | ( | bool | autoextend | ) |
| virtual

Tells the set whether to allow automatic extension of the pool of billboards.

Remarks
  A BillboardSet stores a pool of pre-constructed billboards which are used as needed when a new billboard is requested. This allows applications to create / remove billboards efficiently without incurring construction / destruction costs (a must for sets with lots of billboards like particle effects). This method allows you to configure the behaviour when a new billboard is requested but the billboard pool has been exhausted.

  The default behaviour is to allow the pool to extend (typically this allocates double the current pool of billboards when the pool is expended), equivalent to calling this method with autoExtend = true. If you set the parameter to false however, any attempt to create a new billboard when the pool has expired will simply fail silently, returning a null pointer.

Parameters

  autoextend | `true` to double the pool every time it runs out, `false` to fail silently.

## ◆ setAutoUpdate()

void Ogre::v1::BillboardSet::setAutoUpdate | ( | bool | autoUpdate | ) |

Set the auto update state of this billboard set.

Remarks
  This methods controls the updating policy of the vertex buffer. By default auto update is true so the vertex buffer is being update every time this billboard set is about to be rendered. This behavior best fit when the billboards of this set changes frequently. When using static or semi-static billboards, it is recommended to set auto update to false. In that case one should call notifyBillboardDataChanged method to reflect changes made to the billboards data.

## ◆ setBillboardOrigin()

virtual void Ogre::v1::BillboardSet::setBillboardOrigin | ( | BillboardOrigin | origin | ) |
| virtual

Sets the point which acts as the origin point for all billboards in this set.

Remarks
  This setting controls the fine tuning of where a billboard appears in relation to it's position. It could be that a billboard's position represents it's center (e.g. for fireballs), it could mean the center of the bottom edge (e.g. a tree which is positioned on the ground), the top-left corner (e.g. a cursor).

  The default setting is BBO_CENTER.

Parameters

  origin | A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

## ◆ setBillboardRotationType()

virtual void Ogre::v1::BillboardSet::setBillboardRotationType | ( | BillboardRotationType | rotationType | ) |
| virtual

Sets billboard rotation type.

Remarks
  This setting controls the billboard rotation type, you can deciding rotate the billboard's vertices around their facing direction or rotate the billboard's texture coordinates.

  The default settings is BBR_TEXCOORD.

Parameters

  rotationType | A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ setBillboardsInWorldSpace()

virtual void Ogre::v1::BillboardSet::setBillboardsInWorldSpace | ( | bool | ws | ) |
| inlinevirtual

Sets whether billboards should be treated as being in world space.

Remarks
  This is most useful when you are driving the billboard set from an external data source.

## ◆ setBillboardType()

virtual void Ogre::v1::BillboardSet::setBillboardType | ( | BillboardType | bbt | ) |
| virtual

Sets the type of billboard to render.

Remarks
  The default sort of billboard (BBT_POINT), always has both x and y axes parallel to the camera's local axes. This is fine for 'point' style billboards (e.g. flares, smoke, anything which is symmetrical about a central point) but does not look good for billboards which have an orientation (e.g. an elongated raindrop). In this case, the oriented billboards are more suitable (BBT_ORIENTED_COMMON or BBT_ORIENTED_SELF) since they retain an independent Y axis and only the X axis is generated, perpendicular to both the local Y and the camera Z.

  In some case you might want the billboard has fixed Z axis and doesn't need to face to camera (e.g. an aureola around the player and parallel to the ground). You can use BBT_PERPENDICULAR_SELF which the billboard plane perpendicular to the billboard own direction. Or BBT_PERPENDICULAR_COMMON which the billboard plane perpendicular to the common direction.

Note
  BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON can't guarantee counterclockwise, you might use double-side material (cull_hardware node) to ensure no billboard are culled.

Parameters

  bbt | The type of billboard to render

## ◆ setBounds()

void Ogre::v1::BillboardSet::setBounds | ( | const Aabb & | aabb,
|  | Real | radius )

Set the bounds of the BillboardSet.

Remarks
  You may need to call this if you're injecting billboards manually, and you're relying on the BillboardSet to determine culling.

## ◆ setCommonDirection()

virtual void Ogre::v1::BillboardSet::setCommonDirection | ( | const Vector3 & | vec | ) |
| virtual

Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON or BBT_PERPENDICULAR_COMMON.

Remarks
  Use BBT_ORIENTED_COMMON when you want oriented billboards but you know they are always going to be oriented the same way (e.g. rain in calm weather). It is faster for the system to calculate the billboard vertices if they have a common direction.

  The common direction also use in BBT_PERPENDICULAR_COMMON, in this case the common direction treat as Z axis, and an additional common up-vector was use to determine billboard X and Y axis.

See also
  setCommonUpVector

Parameters

  vec | The direction for all billboards.

Note
  The direction are use as is, never normalised in internal, user are supposed to normalise it himself.

## ◆ setCommonUpVector()

virtual void Ogre::v1::BillboardSet::setCommonUpVector | ( | const Vector3 & | vec | ) |
| virtual

Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON.

Remarks
  Use BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON when you want oriented billboards perpendicular to specify direction vector (or, Z axis), and doesn't face to camera. In this case, we need an additional up-vector to determine the billboard X and Y axis. The generated billboard plane and X-axis guarantee perpendicular to specify direction.

See also
  setCommonDirection

  The specify direction is billboard own direction when billboard type is BBT_PERPENDICULAR_SELF, and it's shared common direction when billboard type is BBT_PERPENDICULAR_COMMON.

Parameters

  vec | The up-vector for all billboards.

Note
  The up-vector are use as is, never normalised in internal, user are supposed to normalise it himself.

## ◆ setCullIndividually()

virtual void Ogre::v1::BillboardSet::setCullIndividually | ( | bool | cullIndividual | ) |
| virtual

Sets whether culling tests billboards in this individually as well as in a group.

Remarks
  Billboard sets are always culled as a whole group, based on a bounding box which encloses all billboards in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual billboards in the set, i.e. to test each individual billboard before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of billboards, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the billboards individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large billboard sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters

  cullIndividual | If true, each billboard is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

## ◆ setDatablock()

void Ogre::v1::BillboardSet::setDatablock | ( | HlmsDatablock * | datablock | ) |
| overridevirtual

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented from Ogre::Renderable.

## ◆ setDefaultDimensions()

virtual void Ogre::v1::BillboardSet::setDefaultDimensions | ( | Real | width,
|  | Real | height )
| virtual

Sets the default dimensions of the billboards in this set.

Remarks
  All billboards in a set are created with these default dimensions. The set will render most efficiently if all the billboards in the set are the default size. It is possible to alter the size of individual billboards at the expense of extra calculation. See the Billboard class for more info.

Parameters

  width | The new default width for the billboards in this set.
  height | The new default height for the billboards in this set.

## ◆ setDefaultHeight()

virtual void Ogre::v1::BillboardSet::setDefaultHeight | ( | Real | height | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setDefaultWidth()

virtual void Ogre::v1::BillboardSet::setDefaultWidth | ( | Real | width | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setMaterial()

void Ogre::v1::BillboardSet::setMaterial | ( | const MaterialPtr & | material | ) |
| overridevirtual

Sets the given material. Overrides HLMS materials.

Reimplemented from Ogre::Renderable.

## ◆ setPointRenderingEnabled()

virtual void Ogre::v1::BillboardSet::setPointRenderingEnabled | ( | bool | enabled | ) |
| virtual

Set whether or not the BillboardSet will use point rendering rather than manually generated quads.

Remarks
  By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state.

  Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply:
  - Only the BBT_POINT type is supported
  - Size and appearance of each billboard is controlled by the material (Pass::setPointSize, Pass::setPointSizeAttenuation, Pass::setPointSpritesEnabled)
  - Per-billboard size is not supported (stems from the above)
  - Per-billboard rotation is not supported, this can only be controlled through texture unit rotation
  - Only BBO_CENTER origin is supported
  - Per-billboard texture coordinates are not supported

  You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option.

Parameters

  enabled | True to enable point rendering, false otherwise

## ◆ setPoolSize()

virtual void Ogre::v1::BillboardSet::setPoolSize | ( | size_t | size | ) |
| virtual

Adjusts the size of the pool of billboards available in this set.

Remarks
  See the BillboardSet::setAutoextend method for full details of the billboard pool. This method adjusts the preallocated size of the pool. If you try to reduce the size of the pool, the set has the option of ignoring you if too many billboards are already in use. Bear in mind that calling this method will incur significant construction / destruction calls so should be avoided in time-critical code. The same goes for auto-extension, try to avoid it by estimating the pool size correctly up-front.

Parameters

  size | The new size for the pool.

## ◆ setSortingEnabled()

virtual void Ogre::v1::BillboardSet::setSortingEnabled | ( | bool | sortenable | ) |
| virtual

Enables sorting for this BillboardSet.

(default: off)

Parameters

  sortenable | true to sort the billboards according to their distance to the camera

## ◆ setTextureCoords()

virtual void Ogre::v1::BillboardSet::setTextureCoords | ( | Ogre::FloatRect const * | coords,
|  | uint16 | numCoords )
| virtual

BillboardSet can use custom texture coordinates for various billboards.

This is useful for selecting one of many particle images out of a tiled texture sheet, or doing flipbook animation within a single texture.

  The generic functionality is setTextureCoords(), which will copy the texture coordinate rects you supply into internal storage for the billboard set. If your texture sheet is a square grid, you can also use setTextureStacksAndSlices() for more convenience, which will construct the set of texture coordinates for you.

  When a Billboard is created, it can be assigned a texture coordinate set from within the sets you specify (that set can also be re-specified later). When drawn, the billboard will use those texture coordinates, rather than the full 0-1 range.

Parameters

  coords | is a vector of texture coordinates (in UV space) to choose from for each billboard created in the set.
  numCoords | is how many such coordinate rectangles there are to choose from.

Remarks
  Set 'coords' to 0 and/or 'numCoords' to 0 to reset the texture coord rects to the initial set of a single rectangle spanning 0 through 1 in both U and V (i e, the entire texture).

See also
  BillboardSet::setTextureStacksAndSlices() Billboard::setTexcoordIndex()

## ◆ setTextureStacksAndSlices()

virtual void Ogre::v1::BillboardSet::setTextureStacksAndSlices | ( | uchar | stacks,
|  | uchar | slices )
| virtual

setTextureStacksAndSlices() will generate texture coordinate rects as if the texture for the billboard set contained 'stacks' rows of 'slices' images each, all equal size.

Thus, if the texture size is 512x512 and 'stacks' is 4 and 'slices' is 8, each sub-rectangle of the texture would be 128 texels tall and 64 texels wide.

Remarks
  This function is short-hand for creating a regular set and calling setTextureCoords() yourself. The numbering used for Billboard::setTexcoordIndex() counts first across, then down, so top-left is 0, the one to the right of that is 1, and the lower-right is stacks*slices-1.

See also
  BillboardSet::setTextureCoords()

## ◆ setUseAccurateFacing()

virtual void Ogre::v1::BillboardSet::setUseAccurateFacing | ( | bool | acc | ) |
| inlinevirtual

Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

Remarks
  By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version.

Parameters

  acc | True to use the slower but more accurate model. Default is false.

The documentation for this class was generated from the following file:

- OgreBillboardSet.h